--- old/usr/src/cmd/tar/tar.c	Thu Oct 18 02:40:12 2012
+++ new/usr/src/cmd/tar/tar.c	Thu Oct 18 02:40:12 2012
@@ -561,6 +561,7 @@
 static	struct stat stbuf;
 
 static	char	*myname;
+static	char	*xtract_chdir = NULL;
 static	int	checkflag = 0;
 static	int	Xflag, Fflag, iflag, hflag, Bflag, Iflag;
 static	int	rflag, xflag, vflag, tflag, mt, svmt, cflag, mflag, pflag;
@@ -1138,6 +1139,20 @@
 					argv[argc] = argv[argc+2];
 					build_table(include_tbl, argv[++argc]);
 				}
+			} else if (strcmp(argv[argc], "-C") == 0) {
+				if (!argv[argc+1]) {
+					(void) fprintf(stderr, gettext("tar: "
+					    "missing argument for -C flag\n"));
+					done(2);
+				} else if (xtract_chdir != NULL) {
+					(void) fprintf(stderr, gettext("tar: "
+					    "extract should have only one -C "
+					    "flag\n"));
+					done(2);
+				} else {
+					argv[argc] = argv[argc+2];
+					xtract_chdir = argv[++argc];
+				}
 			}
 		}
 		if (strcmp(usefile, "-") == 0) {
@@ -1158,6 +1173,12 @@
 			}
 		}
 		if (xflag) {
+			if (xtract_chdir != NULL) {
+				if (tar_chdir(xtract_chdir) < 0) {
+					vperror(1, gettext("can't change "
+					    "directories to %s"), xtract_chdir);
+				}
+			}
 			if (Aflag && vflag)
 				(void) printf(gettext(
 				    "Suppressing absolute pathnames.\n"));
